org.apache.xml.dtm.ref

## Class DTMNodeProxy

- java.lang.Object
- - org.apache.xml.dtm.ref.DTMNodeProxy

- All Implemented Interfaces:
    org.w3c.dom.Attr, org.w3c.dom.CharacterData, org.w3c.dom.Comment, org.w3c.dom.Document, org.w3c.dom.DocumentFragment, org.w3c.dom.Element, org.w3c.dom.Node, org.w3c.dom.ProcessingInstruction, org.w3c.dom.Text

      public class DTMNodeProxy
      extends java.lang.Object
      implements org.w3c.dom.Node, org.w3c.dom.Document, org.w3c.dom.Text, org.w3c.dom.Element, org.w3c.dom.Attr, org.w3c.dom.ProcessingInstruction, org.w3c.dom.Comment, org.w3c.dom.DocumentFragment

  `DTMNodeProxy` presents a DOM Node API front-end to the DTM model.

  It does _not_ attempt to address the "node identity" question; no effort is made to prevent the creation of multiple proxies referring to a single DTM node. Users can create a mechanism for managing this, or relinquish the use of "==" and use the .sameNodeAs() mechanism, which is under consideration for future versions of the DOM.

  DTMNodeProxy may be subclassed further to present specific DOM node types.

  See Also:
    `org.w3c.dom`
  Usage:
    **For internal use only**

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `DTM` | `dtm` The DTM for this node.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DTMNodeProxy(DTM dtm, int node)` Create a DTMNodeProxy Node representing a specific Node in a DTM

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `org.w3c.dom.Node` | `adoptNode(org.w3c.dom.Node source)` NEEDSDOC Method adoptNode NEEDSDOC @param source
    `org.w3c.dom.Node` | `appendChild(org.w3c.dom.Node newChild)`
    `void` | `appendData(java.lang.String arg)`
    `org.w3c.dom.Node` | `cloneNode(boolean deep)`
    `short` | `compareDocumentPosition(org.w3c.dom.Node other)` Compares a node with this node with regard to their position in the document.
    `org.w3c.dom.Attr` | `createAttribute(java.lang.String name)`
    `org.w3c.dom.Attr` | `createAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName)`
    `org.w3c.dom.CDATASection` | `createCDATASection(java.lang.String data)`
    `org.w3c.dom.Comment` | `createComment(java.lang.String data)`
    `org.w3c.dom.DocumentFragment` | `createDocumentFragment()`
    `org.w3c.dom.Element` | `createElement(java.lang.String tagName)`
    `org.w3c.dom.Element` | `createElementNS(java.lang.String namespaceURI, java.lang.String qualifiedName)`
    `org.w3c.dom.EntityReference` | `createEntityReference(java.lang.String name)`
    `org.w3c.dom.ProcessingInstruction` | `createProcessingInstruction(java.lang.String target, java.lang.String data)`
    `org.w3c.dom.Text` | `createTextNode(java.lang.String data)`
    `void` | `deleteData(int offset, int count)`
    `boolean` | `equals(org.w3c.dom.Node node)` Test for equality based on node number.
    `boolean` | `equals(java.lang.Object node)` Test for equality based on node number.
    `java.lang.String` | `getActualEncoding()` DOM Level 3 An attribute specifying the actual encoding of this document.
    `java.lang.String` | `getAttribute(java.lang.String name)`
    `org.w3c.dom.Attr` | `getAttributeNode(java.lang.String name)`
    `org.w3c.dom.Attr` | `getAttributeNodeNS(java.lang.String namespaceURI, java.lang.String localName)`
    `java.lang.String` | `getAttributeNS(java.lang.String namespaceURI, java.lang.String localName)`
    `org.w3c.dom.NamedNodeMap` | `getAttributes()`
    `java.lang.String` | `getBaseURI()` The absolute base URI of this node or `null` if undefined.
    `org.w3c.dom.NodeList` | `getChildNodes()`
    `java.lang.String` | `getData()`
    `org.w3c.dom.DocumentType` | `getDoctype()`
    `org.w3c.dom.Element` | `getDocumentElement()` This is a bit of a problem in DTM, since a DTM may be a Document Fragment and hence not have a clear-cut Document Element.
    `java.lang.String` | `getDocumentURI()` DOM Level 3 The location of the document or `null` if undefined.
    `org.w3c.dom.DOMConfiguration` | `getDomConfig()` The configuration used when `Document.normalizeDocument` is invoked.
    `DTM` | `getDTM()` NON-DOM: Return the DTM model
    `int` | `getDTMNodeNumber()` NON-DOM: Return the DTM node number
    `org.w3c.dom.Element` | `getElementById(java.lang.String elementId)`
    `org.w3c.dom.NodeList` | `getElementsByTagName(java.lang.String tagname)`
    `org.w3c.dom.NodeList` | `getElementsByTagNameNS(java.lang.String namespaceURI, java.lang.String localName)`
    `java.lang.Object` | `getFeature(java.lang.String feature, java.lang.String version)` This method returns a specialized object which implements the specialized APIs of the specified feature and version.
    `org.w3c.dom.Node` | `getFirstChild()`
    `org.w3c.dom.DOMImplementation` | `getImplementation()`
    `java.lang.String` | `getInputEncoding()` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
    `org.w3c.dom.Node` | `getLastChild()`
    `int` | `getLength()`
    `java.lang.String` | `getLocalName()`
    `java.lang.String` | `getName()`
    `java.lang.String` | `getNamespaceURI()`
    `org.w3c.dom.Node` | `getNextSibling()`
    `java.lang.String` | `getNodeName()`
    `short` | `getNodeType()`
    `java.lang.String` | `getNodeValue()`
    `org.w3c.dom.Document` | `getOwnerDocument()`
    `org.w3c.dom.Element` | `getOwnerElement()` Get the owner element of an attribute.
    `org.w3c.dom.Node` | `getOwnerNode()`
    `org.w3c.dom.Node` | `getParentNode()`
    `java.lang.String` | `getPrefix()`
    `org.w3c.dom.Node` | `getPreviousSibling()`
    `org.w3c.dom.TypeInfo` | `getSchemaTypeInfo()`
    `boolean` | `getSpecified()`
    `boolean` | `getStrictErrorChecking()` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
    `java.lang.String` | `getStringValue()`
    `java.lang.String` | `getTagName()`
    `java.lang.String` | `getTarget()` A PI's "target" states what processor channel the PI's data should be directed to.
    `java.lang.String` | `getTextContent()` This attribute returns the text content of this node and its descendants.
    `java.lang.Object` | `getUserData(java.lang.String key)` Retrieves the object associated to a key on a this node.
    `java.lang.String` | `getValue()`
    `java.lang.String` | `getWholeText()` DOM Level 3 Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
    `java.lang.String` | `getXmlEncoding()`
    `boolean` | `getXmlStandalone()`
    `java.lang.String` | `getXmlVersion()`
    `boolean` | `hasAttribute(java.lang.String name)` Method hasAttribute
    `boolean` | `hasAttributeNS(java.lang.String namespaceURI, java.lang.String localName)` Method hasAttributeNS
    `boolean` | `hasAttributes()` Introduced in DOM Level 2.
    `boolean` | `hasChildNodes()`
    `org.w3c.dom.Node` | `importNode(org.w3c.dom.Node importedNode, boolean deep)`
    `org.w3c.dom.Node` | `insertBefore(org.w3c.dom.Node newChild, org.w3c.dom.Node refChild)`
    `void` | `insertData(int offset, java.lang.String arg)`
    `boolean` | `isDefaultNamespace(java.lang.String namespaceURI)` DOM Level 3: This method checks if the specified `namespaceURI` is the default namespace or not.
    `boolean` | `isElementContentWhitespace()` DOM Level 3 Returns whether this text node contains whitespace in element content, often abusively called "ignorable whitespace".
    `boolean` | `isEqualNode(org.w3c.dom.Node arg)` Tests whether two nodes are equal.
    `boolean` | `isId()`
    `boolean` | `isSameNode(org.w3c.dom.Node other)` Returns whether this node is the same node as the given one.
    `boolean` | `isSupported(java.lang.String feature, java.lang.String version)` Ask whether we support a given DOM feature.
    `java.lang.String` | `lookupNamespaceURI(java.lang.String specifiedPrefix)` DOM Level 3: Look up the namespace URI associated to the given prefix, starting from this node.
    `java.lang.String` | `lookupPrefix(java.lang.String namespaceURI)` DOM Level 3: Look up the prefix associated to the given namespace URI, starting from this node.
    `void` | `normalize()`
    `void` | `normalizeDocument()` DOM Level 3 Normalize document.
    `void` | `removeAttribute(java.lang.String name)`
    `org.w3c.dom.Attr` | `removeAttributeNode(org.w3c.dom.Attr oldAttr)`
    `void` | `removeAttributeNS(java.lang.String namespaceURI, java.lang.String localName)`
    `org.w3c.dom.Node` | `removeChild(org.w3c.dom.Node oldChild)`
    `org.w3c.dom.Node` | `renameNode(org.w3c.dom.Node n, java.lang.String namespaceURI, java.lang.String name)` DOM Level 3 Renaming node
    `org.w3c.dom.Node` | `replaceChild(org.w3c.dom.Node newChild, org.w3c.dom.Node oldChild)`
    `void` | `replaceData(int offset, int count, java.lang.String arg)`
    `org.w3c.dom.Text` | `replaceWholeText(java.lang.String content)` DOM Level 3
    `boolean` | `sameNodeAs(org.w3c.dom.Node other)` FUTURE DOM: Test node identity, in lieu of Node==Node
    `void` | `setActualEncoding(java.lang.String value)` DOM Level 3 An attribute specifying the actual encoding of this document.
    `void` | `setAttribute(java.lang.String name, java.lang.String value)`
    `org.w3c.dom.Attr` | `setAttributeNode(org.w3c.dom.Attr newAttr)`
    `org.w3c.dom.Attr` | `setAttributeNodeNS(org.w3c.dom.Attr newAttr)`
    `void` | `setAttributeNS(java.lang.String namespaceURI, java.lang.String qualifiedName, java.lang.String value)`
    `void` | `setData(java.lang.String data)`
    `void` | `setDocumentURI(java.lang.String documentURI)` DOM Level 3
    `void` | `setIdAttribute(boolean id)` NON-DOM: set the type of this attribute to be ID type.
    `void` | `setIdAttribute(java.lang.String name, boolean makeId)` DOM Level 3: register the given attribute node as an ID attribute
    `void` | `setIdAttributeNode(org.w3c.dom.Attr at, boolean makeId)` DOM Level 3: register the given attribute node as an ID attribute
    `void` | `setIdAttributeNS(java.lang.String namespaceURI, java.lang.String localName, boolean makeId)` DOM Level 3: register the given attribute node as an ID attribute
    `void` | `setNodeValue(java.lang.String nodeValue)`
    `void` | `setPrefix(java.lang.String prefix)`
    `void` | `setStrictErrorChecking(boolean strictErrorChecking)` Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004.
    `void` | `setTextContent(java.lang.String textContent)` This attribute returns the text content of this node and its descendants.
    `java.lang.Object` | `setUserData(java.lang.String key, java.lang.Object data, org.w3c.dom.UserDataHandler handler)`
    `void` | `setValue(java.lang.String value)`
    `void` | `setXmlEncoding(java.lang.String xmlEncoding)`
    `void` | `setXmlStandalone(boolean xmlStandalone)`
    `void` | `setXmlVersion(java.lang.String xmlVersion)`
    `org.w3c.dom.Text` | `splitText(int offset)`
    `java.lang.String` | `substringData(int offset, int count)`
    `boolean` | `supports(java.lang.String feature, java.lang.String version)` Ask whether we support a given DOM feature.

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### dtm

          public DTM dtm

      The DTM for this node.

  - ### Constructor Detail

    - #### DTMNodeProxy

          public DTMNodeProxy(DTM dtm,
                              int node)

      Create a DTMNodeProxy Node representing a specific Node in a DTM
      Parameters:
        `dtm` - The DTM Reference, must be non-null.
        `node` - The DTM node handle.

  - ### Method Detail

    - #### getDTM

          public final DTM getDTM()

      NON-DOM: Return the DTM model
      Returns:
        The DTM that this proxy is a representative for.

    - #### getDTMNodeNumber

          public final int getDTMNodeNumber()

      NON-DOM: Return the DTM node number
      Returns:
        The DTM node handle.

    - #### equals

          public final boolean equals(org.w3c.dom.Node node)

      Test for equality based on node number.
      Parameters:
        `node` - A DTM node proxy reference.
      Returns:
        true if the given node has the same handle as this node.

    - #### equals

          public final boolean equals(java.lang.Object node)

      Test for equality based on node number.
      Overrides:
        `equals` in class `java.lang.Object`
      Parameters:
        `node` - A DTM node proxy reference.
      Returns:
        true if the given node has the same handle as this node.

    - #### sameNodeAs

          public final boolean sameNodeAs(org.w3c.dom.Node other)

      FUTURE DOM: Test node identity, in lieu of Node==Node
      Parameters:
        `other` -
      Returns:
        true if the given node has the same handle as this node.

    - #### getNodeName

          public final java.lang.String getNodeName()

      Specified by:
        `getNodeName` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getTarget

          public final java.lang.String getTarget()

      A PI's "target" states what processor channel the PI's data should be directed to. It is defined differently in HTML and XML.

      In XML, a PI's "target" is the first (whitespace-delimited) token following the " In HTML, target is always null.

      Note that getNodeName is aliased to getTarget.

      Specified by:
        `getTarget` in interface `org.w3c.dom.ProcessingInstruction`

    - #### getLocalName

          public final java.lang.String getLocalName()

      Specified by:
        `getLocalName` in interface `org.w3c.dom.Node`
      See Also:
        `as of DOM Level 2`

    - #### getPrefix

          public final java.lang.String getPrefix()

      Specified by:
        `getPrefix` in interface `org.w3c.dom.Node`
      Returns:
        The prefix for this node.
      See Also:
        `as of DOM Level 2`

    - #### setPrefix

          public final void setPrefix(java.lang.String prefix)
                               throws org.w3c.dom.DOMException

      Specified by:
        `setPrefix` in interface `org.w3c.dom.Node`
      Parameters:
        `prefix` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `as of DOM Level 2 -- DTMNodeProxy is read-only`

    - #### getNamespaceURI

          public final java.lang.String getNamespaceURI()

      Specified by:
        `getNamespaceURI` in interface `org.w3c.dom.Node`
      See Also:
        `as of DOM Level 2`

    - #### supports

          public final boolean supports(java.lang.String feature,
                                        java.lang.String version)

      Ask whether we support a given DOM feature. In fact, we do not _fully_ support any DOM feature -- we're a read-only subset -- so arguably we should always return false. Or we could say that we support DOM Core Level 2 but all nodes are read-only. Unclear which answer is least misleading. NON-DOM method. This was present in early drafts of DOM Level 2, but was renamed isSupported. It's present here only because it's cheap, harmless, and might help some poor fool who is still trying to use an early Working Draft of the DOM.
      Parameters:
        `feature` -
        `version` -
      Returns:
        false

    - #### isSupported

          public final boolean isSupported(java.lang.String feature,
                                           java.lang.String version)

      Ask whether we support a given DOM feature. In fact, we do not _fully_ support any DOM feature -- we're a read-only subset -- so arguably we should always return false.
      Specified by:
        `isSupported` in interface `org.w3c.dom.Node`
      Parameters:
        `feature` -
        `version` -
      Returns:
        false
      See Also:
        `as of DOM Level 2`

    - #### getNodeValue

          public final java.lang.String getNodeValue()
                                              throws org.w3c.dom.DOMException

      Specified by:
        `getNodeValue` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Node`

    - #### getStringValue

          public final java.lang.String getStringValue()
                                                throws org.w3c.dom.DOMException

      Returns:
        The string value of the node
      Throws:
        `org.w3c.dom.DOMException`

    - #### setNodeValue

          public final void setNodeValue(java.lang.String nodeValue)
                                  throws org.w3c.dom.DOMException

      Specified by:
        `setNodeValue` in interface `org.w3c.dom.Node`
      Parameters:
        `nodeValue` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `-- DTMNodeProxy is read-only`

    - #### getNodeType

          public final short getNodeType()

      Specified by:
        `getNodeType` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getParentNode

          public final org.w3c.dom.Node getParentNode()

      Specified by:
        `getParentNode` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getOwnerNode

          public final org.w3c.dom.Node getOwnerNode()

      See Also:
        `Node`

    - #### getChildNodes

          public final org.w3c.dom.NodeList getChildNodes()

      Specified by:
        `getChildNodes` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getFirstChild

          public final org.w3c.dom.Node getFirstChild()

      Specified by:
        `getFirstChild` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getLastChild

          public final org.w3c.dom.Node getLastChild()

      Specified by:
        `getLastChild` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getPreviousSibling

          public final org.w3c.dom.Node getPreviousSibling()

      Specified by:
        `getPreviousSibling` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getNextSibling

          public final org.w3c.dom.Node getNextSibling()

      Specified by:
        `getNextSibling` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### getAttributes

          public final org.w3c.dom.NamedNodeMap getAttributes()

      Specified by:
        `getAttributes` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### hasAttribute

          public boolean hasAttribute(java.lang.String name)

      Method hasAttribute
      Specified by:
        `hasAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` -

    - #### hasAttributeNS

          public boolean hasAttributeNS(java.lang.String namespaceURI,
                                        java.lang.String localName)

      Method hasAttributeNS
      Specified by:
        `hasAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` -
        `localName` -

    - #### getOwnerDocument

          public final org.w3c.dom.Document getOwnerDocument()

      Specified by:
        `getOwnerDocument` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### insertBefore

          public final org.w3c.dom.Node insertBefore(org.w3c.dom.Node newChild,
                                                     org.w3c.dom.Node refChild)
                                              throws org.w3c.dom.DOMException

      Specified by:
        `insertBefore` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` -
        `refChild` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `-- DTMNodeProxy is read-only`

    - #### replaceChild

          public final org.w3c.dom.Node replaceChild(org.w3c.dom.Node newChild,
                                                     org.w3c.dom.Node oldChild)
                                              throws org.w3c.dom.DOMException

      Specified by:
        `replaceChild` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` -
        `oldChild` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `-- DTMNodeProxy is read-only`

    - #### removeChild

          public final org.w3c.dom.Node removeChild(org.w3c.dom.Node oldChild)
                                             throws org.w3c.dom.DOMException

      Specified by:
        `removeChild` in interface `org.w3c.dom.Node`
      Parameters:
        `oldChild` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `-- DTMNodeProxy is read-only`

    - #### appendChild

          public final org.w3c.dom.Node appendChild(org.w3c.dom.Node newChild)
                                             throws org.w3c.dom.DOMException

      Specified by:
        `appendChild` in interface `org.w3c.dom.Node`
      Parameters:
        `newChild` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `-- DTMNodeProxy is read-only`

    - #### hasChildNodes

          public final boolean hasChildNodes()

      Specified by:
        `hasChildNodes` in interface `org.w3c.dom.Node`
      See Also:
        `Node`

    - #### cloneNode

          public final org.w3c.dom.Node cloneNode(boolean deep)

      Specified by:
        `cloneNode` in interface `org.w3c.dom.Node`
      Parameters:
        `deep` -
      See Also:
        `-- DTMNodeProxy is read-only`

    - #### getDoctype

          public final org.w3c.dom.DocumentType getDoctype()

      Specified by:
        `getDoctype` in interface `org.w3c.dom.Document`
      See Also:
        `Document`

    - #### getImplementation

          public final org.w3c.dom.DOMImplementation getImplementation()

      Specified by:
        `getImplementation` in interface `org.w3c.dom.Document`
      See Also:
        `Document`

    - #### getDocumentElement

          public final org.w3c.dom.Element getDocumentElement()

      This is a bit of a problem in DTM, since a DTM may be a Document Fragment and hence not have a clear-cut Document Element. We can make it work in the well-formed cases but would that be confusing for others?
      Specified by:
        `getDocumentElement` in interface `org.w3c.dom.Document`
      See Also:
        `Document`

    - #### createElement

          public final org.w3c.dom.Element createElement(java.lang.String tagName)
                                                  throws org.w3c.dom.DOMException

      Specified by:
        `createElement` in interface `org.w3c.dom.Document`
      Parameters:
        `tagName` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Document`

    - #### createDocumentFragment

          public final org.w3c.dom.DocumentFragment createDocumentFragment()

      Specified by:
        `createDocumentFragment` in interface `org.w3c.dom.Document`
      See Also:
        `Document`

    - #### createTextNode

          public final org.w3c.dom.Text createTextNode(java.lang.String data)

      Specified by:
        `createTextNode` in interface `org.w3c.dom.Document`
      Parameters:
        `data` -
      See Also:
        `Document`

    - #### createComment

          public final org.w3c.dom.Comment createComment(java.lang.String data)

      Specified by:
        `createComment` in interface `org.w3c.dom.Document`
      Parameters:
        `data` -
      See Also:
        `Document`

    - #### createCDATASection

          public final org.w3c.dom.CDATASection createCDATASection(java.lang.String data)
                                                            throws org.w3c.dom.DOMException

      Specified by:
        `createCDATASection` in interface `org.w3c.dom.Document`
      Parameters:
        `data` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Document`

    - #### createProcessingInstruction

          public final org.w3c.dom.ProcessingInstruction createProcessingInstruction(java.lang.String target,
                                                                                     java.lang.String data)
                                                                              throws org.w3c.dom.DOMException

      Specified by:
        `createProcessingInstruction` in interface `org.w3c.dom.Document`
      Parameters:
        `target` -
        `data` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Document`

    - #### createAttribute

          public final org.w3c.dom.Attr createAttribute(java.lang.String name)
                                                 throws org.w3c.dom.DOMException

      Specified by:
        `createAttribute` in interface `org.w3c.dom.Document`
      Parameters:
        `name` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Document`

    - #### createEntityReference

          public final org.w3c.dom.EntityReference createEntityReference(java.lang.String name)
                                                                  throws org.w3c.dom.DOMException

      Specified by:
        `createEntityReference` in interface `org.w3c.dom.Document`
      Parameters:
        `name` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Document`

    - #### getElementsByTagName

          public final org.w3c.dom.NodeList getElementsByTagName(java.lang.String tagname)

      Specified by:
        `getElementsByTagName` in interface `org.w3c.dom.Document`
      Specified by:
        `getElementsByTagName` in interface `org.w3c.dom.Element`
      Parameters:
        `tagname` -
      See Also:
        `Document`

    - #### importNode

          public final org.w3c.dom.Node importNode(org.w3c.dom.Node importedNode,
                                                   boolean deep)
                                            throws org.w3c.dom.DOMException

      Specified by:
        `importNode` in interface `org.w3c.dom.Document`
      Parameters:
        `importedNode` -
        `deep` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `as of DOM Level 2 -- DTMNodeProxy is read-only`

    - #### createElementNS

          public final org.w3c.dom.Element createElementNS(java.lang.String namespaceURI,
                                                           java.lang.String qualifiedName)
                                                    throws org.w3c.dom.DOMException

      Specified by:
        `createElementNS` in interface `org.w3c.dom.Document`
      Parameters:
        `namespaceURI` -
        `qualifiedName` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `as of DOM Level 2`

    - #### createAttributeNS

          public final org.w3c.dom.Attr createAttributeNS(java.lang.String namespaceURI,
                                                          java.lang.String qualifiedName)
                                                   throws org.w3c.dom.DOMException

      Specified by:
        `createAttributeNS` in interface `org.w3c.dom.Document`
      Parameters:
        `namespaceURI` -
        `qualifiedName` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `as of DOM Level 2`

    - #### getElementsByTagNameNS

          public final org.w3c.dom.NodeList getElementsByTagNameNS(java.lang.String namespaceURI,
                                                                   java.lang.String localName)

      Specified by:
        `getElementsByTagNameNS` in interface `org.w3c.dom.Document`
      Specified by:
        `getElementsByTagNameNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` -
        `localName` -
      See Also:
        `as of DOM Level 2`

    - #### getElementById

          public final org.w3c.dom.Element getElementById(java.lang.String elementId)

      Specified by:
        `getElementById` in interface `org.w3c.dom.Document`
      Parameters:
        `elementId` -
      See Also:
        `as of DOM Level 2`

    - #### splitText

          public final org.w3c.dom.Text splitText(int offset)
                                           throws org.w3c.dom.DOMException

      Specified by:
        `splitText` in interface `org.w3c.dom.Text`
      Parameters:
        `offset` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Text`

    - #### getData

          public final java.lang.String getData()
                                         throws org.w3c.dom.DOMException

      Specified by:
        `getData` in interface `org.w3c.dom.CharacterData`
      Specified by:
        `getData` in interface `org.w3c.dom.ProcessingInstruction`
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### setData

          public final void setData(java.lang.String data)
                             throws org.w3c.dom.DOMException

      Specified by:
        `setData` in interface `org.w3c.dom.CharacterData`
      Specified by:
        `setData` in interface `org.w3c.dom.ProcessingInstruction`
      Parameters:
        `data` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### getLength

          public final int getLength()

      Specified by:
        `getLength` in interface `org.w3c.dom.CharacterData`
      See Also:
        `CharacterData`

    - #### substringData

          public final java.lang.String substringData(int offset,
                                                      int count)
                                               throws org.w3c.dom.DOMException

      Specified by:
        `substringData` in interface `org.w3c.dom.CharacterData`
      Parameters:
        `offset` -
        `count` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### appendData

          public final void appendData(java.lang.String arg)
                                throws org.w3c.dom.DOMException

      Specified by:
        `appendData` in interface `org.w3c.dom.CharacterData`
      Parameters:
        `arg` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### insertData

          public final void insertData(int offset,
                                       java.lang.String arg)
                                throws org.w3c.dom.DOMException

      Specified by:
        `insertData` in interface `org.w3c.dom.CharacterData`
      Parameters:
        `offset` -
        `arg` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### deleteData

          public final void deleteData(int offset,
                                       int count)
                                throws org.w3c.dom.DOMException

      Specified by:
        `deleteData` in interface `org.w3c.dom.CharacterData`
      Parameters:
        `offset` -
        `count` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### replaceData

          public final void replaceData(int offset,
                                        int count,
                                        java.lang.String arg)
                                 throws org.w3c.dom.DOMException

      Specified by:
        `replaceData` in interface `org.w3c.dom.CharacterData`
      Parameters:
        `offset` -
        `count` -
        `arg` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `CharacterData`

    - #### getTagName

          public final java.lang.String getTagName()

      Specified by:
        `getTagName` in interface `org.w3c.dom.Element`
      See Also:
        `Element`

    - #### getAttribute

          public final java.lang.String getAttribute(java.lang.String name)

      Specified by:
        `getAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` -
      See Also:
        `Element`

    - #### setAttribute

          public final void setAttribute(java.lang.String name,
                                         java.lang.String value)
                                  throws org.w3c.dom.DOMException

      Specified by:
        `setAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` -
        `value` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### removeAttribute

          public final void removeAttribute(java.lang.String name)
                                     throws org.w3c.dom.DOMException

      Specified by:
        `removeAttribute` in interface `org.w3c.dom.Element`
      Parameters:
        `name` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### getAttributeNode

          public final org.w3c.dom.Attr getAttributeNode(java.lang.String name)

      Specified by:
        `getAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `name` -
      See Also:
        `Element`

    - #### setAttributeNode

          public final org.w3c.dom.Attr setAttributeNode(org.w3c.dom.Attr newAttr)
                                                  throws org.w3c.dom.DOMException

      Specified by:
        `setAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `newAttr` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### removeAttributeNode

          public final org.w3c.dom.Attr removeAttributeNode(org.w3c.dom.Attr oldAttr)
                                                     throws org.w3c.dom.DOMException

      Specified by:
        `removeAttributeNode` in interface `org.w3c.dom.Element`
      Parameters:
        `oldAttr` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### hasAttributes

          public boolean hasAttributes()

      Introduced in DOM Level 2.
      Specified by:
        `hasAttributes` in interface `org.w3c.dom.Node`

    - #### normalize

          public final void normalize()

      Specified by:
        `normalize` in interface `org.w3c.dom.Node`
      See Also:
        `Element`

    - #### getAttributeNS

          public final java.lang.String getAttributeNS(java.lang.String namespaceURI,
                                                       java.lang.String localName)

      Specified by:
        `getAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` -
        `localName` -
      See Also:
        `Element`

    - #### setAttributeNS

          public final void setAttributeNS(java.lang.String namespaceURI,
                                           java.lang.String qualifiedName,
                                           java.lang.String value)
                                    throws org.w3c.dom.DOMException

      Specified by:
        `setAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` -
        `qualifiedName` -
        `value` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### removeAttributeNS

          public final void removeAttributeNS(java.lang.String namespaceURI,
                                              java.lang.String localName)
                                       throws org.w3c.dom.DOMException

      Specified by:
        `removeAttributeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` -
        `localName` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### getAttributeNodeNS

          public final org.w3c.dom.Attr getAttributeNodeNS(java.lang.String namespaceURI,
                                                           java.lang.String localName)

      Specified by:
        `getAttributeNodeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `namespaceURI` -
        `localName` -
      See Also:
        `Element`

    - #### setAttributeNodeNS

          public final org.w3c.dom.Attr setAttributeNodeNS(org.w3c.dom.Attr newAttr)
                                                    throws org.w3c.dom.DOMException

      Specified by:
        `setAttributeNodeNS` in interface `org.w3c.dom.Element`
      Parameters:
        `newAttr` -
      Throws:
        `org.w3c.dom.DOMException`
      See Also:
        `Element`

    - #### getName

          public final java.lang.String getName()

      Specified by:
        `getName` in interface `org.w3c.dom.Attr`
      See Also:
        `Attr`

    - #### getSpecified

          public final boolean getSpecified()

      Specified by:
        `getSpecified` in interface `org.w3c.dom.Attr`
      See Also:
        `Attr`

    - #### getValue

          public final java.lang.String getValue()

      Specified by:
        `getValue` in interface `org.w3c.dom.Attr`
      See Also:
        `Attr`

    - #### setValue

          public final void setValue(java.lang.String value)

      Specified by:
        `setValue` in interface `org.w3c.dom.Attr`
      Parameters:
        `value` -
      See Also:
        `Attr`

    - #### getOwnerElement

          public final org.w3c.dom.Element getOwnerElement()

      Get the owner element of an attribute.
      Specified by:
        `getOwnerElement` in interface `org.w3c.dom.Attr`
      See Also:
        `as of DOM Level 2`

    - #### adoptNode

          public org.w3c.dom.Node adoptNode(org.w3c.dom.Node source)
                                     throws org.w3c.dom.DOMException

      NEEDSDOC Method adoptNode NEEDSDOC @param source
      Specified by:
        `adoptNode` in interface `org.w3c.dom.Document`
      Throws:
        `org.w3c.dom.DOMException`

    - #### getInputEncoding

          public java.lang.String getInputEncoding()

      Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

      An attribute specifying, as part of the XML declaration, the encoding of this document. This is `null` when unspecified.

      Specified by:
        `getInputEncoding` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### getStrictErrorChecking

          public boolean getStrictErrorChecking()

      Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

      An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

      Specified by:
        `getStrictErrorChecking` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### setStrictErrorChecking

          public void setStrictErrorChecking(boolean strictErrorChecking)

      Based on the Document Object Model (DOM) Level 3 Core Specification of 07 April 2004..

      An attribute specifying whether errors checking is enforced or not. When set to `false`, the implementation is free to not test every possible error case normally defined on DOM operations, and not raise any `DOMException`. In case of error, the behavior is undefined. This attribute is `true` by defaults.

      Specified by:
        `setStrictErrorChecking` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3 NEEDSDOC @param strictErrorChecking

    - #### setUserData

          public java.lang.Object setUserData(java.lang.String key,
                                              java.lang.Object data,
                                              org.w3c.dom.UserDataHandler handler)

      Specified by:
        `setUserData` in interface `org.w3c.dom.Node`

    - #### getUserData

          public java.lang.Object getUserData(java.lang.String key)

      Retrieves the object associated to a key on a this node. The object must first have been set to this node by calling `setUserData` with the same key.
      Specified by:
        `getUserData` in interface `org.w3c.dom.Node`
      Parameters:
        `key` - The key the object is associated to.
      Returns:
        Returns the `DOMObject` associated to the given key on this node, or `null` if there was none.
      Since:
        DOM Level 3

    - #### getFeature

          public java.lang.Object getFeature(java.lang.String feature,
                                             java.lang.String version)

      This method returns a specialized object which implements the specialized APIs of the specified feature and version. The specialized object may also be obtained by using binding-specific casting methods but is not necessarily expected to, as discussed in Mixed DOM implementations.
      Specified by:
        `getFeature` in interface `org.w3c.dom.Node`
      Parameters:
        `feature` - The name of the feature requested (case-insensitive).
        `version` - This is the version number of the feature to test. If the version is `null` or the empty string, supporting any version of the feature will cause the method to return an object that supports at least one version of the feature.
      Returns:
        Returns an object which implements the specialized APIs of the specified feature and version, if any, or `null` if there is no object which implements interfaces associated with that feature. If the `DOMObject` returned by this method implements the `Node` interface, it must delegate to the primary core `Node` and not return results inconsistent with the primary core `Node` such as attributes, childNodes, etc.
      Since:
        DOM Level 3

    - #### isEqualNode

          public boolean isEqualNode(org.w3c.dom.Node arg)

      Tests whether two nodes are equal.
      This method tests for equality of nodes, not sameness (i.e., whether the two nodes are references to the same object) which can be tested with `Node.isSameNode`. All nodes that are the same will also be equal, though the reverse may not be true.
      Two nodes are equal if and only if the following conditions are satisfied: The two nodes are of the same type.The following string attributes are equal: `nodeName`, `localName`, `namespaceURI`, `prefix`, `nodeValue` , `baseURI`. This is: they are both `null`, or they have the same length and are character for character identical. The `attributes` `NamedNodeMaps` are equal. This is: they are both `null`, or they have the same length and for each node that exists in one map there is a node that exists in the other map and is equal, although not necessarily at the same index.The `childNodes` `NodeLists` are equal. This is: they are both `null`, or they have the same length and contain equal nodes at the same index. This is true for `Attr` nodes as for any other type of node. Note that normalization can affect equality; to avoid this, nodes should be normalized before being compared.
      For two `DocumentType` nodes to be equal, the following conditions must also be satisfied: The following string attributes are equal: `publicId`, `systemId`, `internalSubset`.The `entities` `NamedNodeMaps` are equal.The `notations` `NamedNodeMaps` are equal.
      On the other hand, the following do not affect equality: the `ownerDocument` attribute, the `specified` attribute for `Attr` nodes, the `isWhitespaceInElementContent` attribute for `Text` nodes, as well as any user data or event listeners registered on the nodes.
      Specified by:
        `isEqualNode` in interface `org.w3c.dom.Node`
      Parameters:
        `arg` - The node to compare equality with.
        `deep` - If `true`, recursively compare the subtrees; if `false`, compare only the nodes themselves (and its attributes, if it is an `Element`).
      Returns:
        If the nodes, and possibly subtrees are equal, `true` otherwise `false`.
      Since:
        DOM Level 3

    - #### lookupNamespaceURI

          public java.lang.String lookupNamespaceURI(java.lang.String specifiedPrefix)

      DOM Level 3: Look up the namespace URI associated to the given prefix, starting from this node. Use lookupNamespaceURI(null) to lookup the default namespace
      Specified by:
        `lookupNamespaceURI` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` -
      Returns:
        th URI for the namespace
      Since:
        DOM Level 3

    - #### isDefaultNamespace

          public boolean isDefaultNamespace(java.lang.String namespaceURI)

      DOM Level 3: This method checks if the specified `namespaceURI` is the default namespace or not.
      Specified by:
        `isDefaultNamespace` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` - The namespace URI to look for.
      Returns:
        `true` if the specified `namespaceURI` is the default namespace, `false` otherwise.
      Since:
        DOM Level 3

    - #### lookupPrefix

          public java.lang.String lookupPrefix(java.lang.String namespaceURI)

      DOM Level 3: Look up the prefix associated to the given namespace URI, starting from this node.
      Specified by:
        `lookupPrefix` in interface `org.w3c.dom.Node`
      Parameters:
        `namespaceURI` -
      Returns:
        the prefix for the namespace

    - #### isSameNode

          public boolean isSameNode(org.w3c.dom.Node other)

      Returns whether this node is the same node as the given one.
      This method provides a way to determine whether two `Node` references returned by the implementation reference the same object. When two `Node` references are references to the same object, even if through a proxy, the references may be used completely interchangably, such that all attributes have the same values and calling the same DOM method on either reference always has exactly the same effect.
      Specified by:
        `isSameNode` in interface `org.w3c.dom.Node`
      Parameters:
        `other` - The node to test against.
      Returns:
        Returns `true` if the nodes are the same, `false` otherwise.
      Since:
        DOM Level 3

    - #### setTextContent

          public void setTextContent(java.lang.String textContent)
                              throws org.w3c.dom.DOMException

      This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
      ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
      DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

      Specified by:
        `setTextContent` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
      Since:
        DOM Level 3

    - #### getTextContent

          public java.lang.String getTextContent()
                                          throws org.w3c.dom.DOMException

      This attribute returns the text content of this node and its descendants. When it is defined to be null, setting it has no effect. When set, any possible children this node may have are removed and replaced by a single `Text` node containing the string this attribute is set to. On getting, no serialization is performed, the returned string does not contain any markup. No whitespace normalization is performed, the returned string does not contain the element content whitespaces . Similarly, on setting, no parsing is performed either, the input string is taken as pure textual content.
      The string returned is made of the text content of this node depending on its type, as defined below:

      Node type | Content
      --- | ---
      ELEMENT_NODE, ENTITY_NODE, ENTITY_REFERENCE_NODE, DOCUMENT_FRAGMENT_NODE | concatenation of the `textContent` attribute value of every child node, excluding COMMENT_NODE and PROCESSING_INSTRUCTION_NODE nodes
      ATTRIBUTE_NODE, TEXT_NODE, CDATA_SECTION_NODE, COMMENT_NODE, PROCESSING_INSTRUCTION_NODE | `nodeValue`
      DOCUMENT_NODE, DOCUMENT_TYPE_NODE, NOTATION_NODE | null

      Specified by:
        `getTextContent` in interface `org.w3c.dom.Node`
      Throws:
        `org.w3c.dom.DOMException` - NO_MODIFICATION_ALLOWED_ERR: Raised when the node is readonly.
        `org.w3c.dom.DOMException` - DOMSTRING_SIZE_ERR: Raised when it would return more characters than fit in a `DOMString` variable on the implementation platform.
      Since:
        DOM Level 3

    - #### compareDocumentPosition

          public short compareDocumentPosition(org.w3c.dom.Node other)
                                        throws org.w3c.dom.DOMException

      Compares a node with this node with regard to their position in the document.
      Specified by:
        `compareDocumentPosition` in interface `org.w3c.dom.Node`
      Parameters:
        `other` - The node to compare against this node.
      Returns:
        Returns how the given node is positioned relatively to this node.
      Throws:
        `org.w3c.dom.DOMException`
      Since:
        DOM Level 3

    - #### getBaseURI

          public java.lang.String getBaseURI()

      The absolute base URI of this node or `null` if undefined. This value is computed according to . However, when the `Document` supports the feature "HTML" , the base URI is computed using first the value of the href attribute of the HTML BASE element if any, and the value of the `documentURI` attribute from the `Document` interface otherwise.
      When the node is an `Element`, a `Document` or a a `ProcessingInstruction`, this attribute represents the properties [base URI] defined in . When the node is a `Notation`, an `Entity`, or an `EntityReference`, this attribute represents the properties [declaration base URI] in the . How will this be affected by resolution of relative namespace URIs issue?It's not.Should this only be on Document, Element, ProcessingInstruction, Entity, and Notation nodes, according to the infoset? If not, what is it equal to on other nodes? Null? An empty string? I think it should be the parent's.No.Should this be read-only and computed or and actual read-write attribute?Read-only and computed (F2F 19 Jun 2000 and teleconference 30 May 2001).If the base HTML element is not yet attached to a document, does the insert change the Document.baseURI? Yes. (F2F 26 Sep 2001)
      Specified by:
        `getBaseURI` in interface `org.w3c.dom.Node`
      Since:
        DOM Level 3

    - #### renameNode

          public org.w3c.dom.Node renameNode(org.w3c.dom.Node n,
                                             java.lang.String namespaceURI,
                                             java.lang.String name)
                                      throws org.w3c.dom.DOMException

      DOM Level 3 Renaming node
      Specified by:
        `renameNode` in interface `org.w3c.dom.Document`
      Throws:
        `org.w3c.dom.DOMException`

    - #### normalizeDocument

          public void normalizeDocument()

      DOM Level 3 Normalize document.
      Specified by:
        `normalizeDocument` in interface `org.w3c.dom.Document`

    - #### getDomConfig

          public org.w3c.dom.DOMConfiguration getDomConfig()

      The configuration used when `Document.normalizeDocument` is invoked.
      Specified by:
        `getDomConfig` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### setDocumentURI

          public void setDocumentURI(java.lang.String documentURI)

      DOM Level 3
      Specified by:
        `setDocumentURI` in interface `org.w3c.dom.Document`

    - #### getDocumentURI

          public java.lang.String getDocumentURI()

      DOM Level 3 The location of the document or `null` if undefined.
      Beware that when the `Document` supports the feature "HTML" , the href attribute of the HTML BASE element takes precedence over this attribute.
      Specified by:
        `getDocumentURI` in interface `org.w3c.dom.Document`
      Since:
        DOM Level 3

    - #### getActualEncoding

          public java.lang.String getActualEncoding()

      DOM Level 3 An attribute specifying the actual encoding of this document. This is `null` otherwise.
      This attribute represents the property [character encoding scheme] defined in .
      Since:
        DOM Level 3

    - #### setActualEncoding

          public void setActualEncoding(java.lang.String value)

      DOM Level 3 An attribute specifying the actual encoding of this document. This is `null` otherwise.
      This attribute represents the property [character encoding scheme] defined in .
      Since:
        DOM Level 3

    - #### replaceWholeText

          public org.w3c.dom.Text replaceWholeText(java.lang.String content)
                                            throws org.w3c.dom.DOMException

      DOM Level 3
      Specified by:
        `replaceWholeText` in interface `org.w3c.dom.Text`
      Throws:
        `org.w3c.dom.DOMException`

    - #### getWholeText

          public java.lang.String getWholeText()

      DOM Level 3 Returns all text of `Text` nodes logically-adjacent text nodes to this node, concatenated in document order.
      Specified by:
        `getWholeText` in interface `org.w3c.dom.Text`
      Since:
        DOM Level 3

    - #### isElementContentWhitespace

          public boolean isElementContentWhitespace()

      DOM Level 3 Returns whether this text node contains whitespace in element content, often abusively called "ignorable whitespace".
      Specified by:
        `isElementContentWhitespace` in interface `org.w3c.dom.Text`

    - #### setIdAttribute

          public void setIdAttribute(boolean id)

      NON-DOM: set the type of this attribute to be ID type.
      Parameters:
        `id` -

    - #### setIdAttribute

          public void setIdAttribute(java.lang.String name,
                                     boolean makeId)

      DOM Level 3: register the given attribute node as an ID attribute
      Specified by:
        `setIdAttribute` in interface `org.w3c.dom.Element`

    - #### setIdAttributeNode

          public void setIdAttributeNode(org.w3c.dom.Attr at,
                                         boolean makeId)

      DOM Level 3: register the given attribute node as an ID attribute
      Specified by:
        `setIdAttributeNode` in interface `org.w3c.dom.Element`

    - #### setIdAttributeNS

          public void setIdAttributeNS(java.lang.String namespaceURI,
                                       java.lang.String localName,
                                       boolean makeId)

      DOM Level 3: register the given attribute node as an ID attribute
      Specified by:
        `setIdAttributeNS` in interface `org.w3c.dom.Element`

    - #### getSchemaTypeInfo

          public org.w3c.dom.TypeInfo getSchemaTypeInfo()

      Specified by:
        `getSchemaTypeInfo` in interface `org.w3c.dom.Attr`
      Specified by:
        `getSchemaTypeInfo` in interface `org.w3c.dom.Element`

    - #### isId

          public boolean isId()

      Specified by:
        `isId` in interface `org.w3c.dom.Attr`

    - #### getXmlEncoding

          public java.lang.String getXmlEncoding()

      Specified by:
        `getXmlEncoding` in interface `org.w3c.dom.Document`

    - #### setXmlEncoding

          public void setXmlEncoding(java.lang.String xmlEncoding)

    - #### getXmlStandalone

          public boolean getXmlStandalone()

      Specified by:
        `getXmlStandalone` in interface `org.w3c.dom.Document`

    - #### setXmlStandalone

          public void setXmlStandalone(boolean xmlStandalone)
                                throws org.w3c.dom.DOMException

      Specified by:
        `setXmlStandalone` in interface `org.w3c.dom.Document`
      Throws:
        `org.w3c.dom.DOMException`

    - #### getXmlVersion

          public java.lang.String getXmlVersion()

      Specified by:
        `getXmlVersion` in interface `org.w3c.dom.Document`

    - #### setXmlVersion

          public void setXmlVersion(java.lang.String xmlVersion)
                             throws org.w3c.dom.DOMException

      Specified by:
        `setXmlVersion` in interface `org.w3c.dom.Document`
      Throws:
        `org.w3c.dom.DOMException`

Copyright © 2023 Apache XML Project. All Rights Reserved.